;; as per message-goto-body
(defun message-body-pos ()
  (save-excursion
    (goto-char (point-min))
    (or (search-forward (concat "\n" mail-header-separator "\n") nil t)
	(search-forward "\n\n" nil t)
	(point-max))))

(defun message-do-auto-fill ()
  (if (not (or (< (point) (message-body-pos))
	       (save-excursion (beginning-of-line) (looking-at "<#part"))))
      (funcall (default-value 'normal-auto-fill-function))))

(add-hook 'message-mode-hook
	  '(lambda ()
	     
	     (setq auto-fill-inhibit-regexp nil)
	     
	     (set (make-local-variable 'normal-auto-fill-function)
		  'message-do-auto-fill)
	     
	     ;; this bit only because text-mode-hook might have
	     ;; already turned on auto-fill-mode
	     (if auto-fill-function
		 (setq auto-fill-function 'message-do-auto-fill))
	     ))
